//=============================================================================
//
// file :        LabmaxTop.h
//
// description : Include for the LabmaxTop class.
//
// project :	LabMaxTOP
//
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _LABMAXTOP_H
#define _LABMAXTOP_H

#include <tango.h>
#include <math.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <signal.h>
#include <netdb.h>

//#include <buffer.h>

//#include "labmaxtop.h"

/**
 * @author	$Author: graziano $
 * @version	$Revision: 1.13 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------
class readthread;
class pwrthread;

#define DEF_CFACTOR	10
#define DEF_COFFSET		0
#define DEF_NUM_AVG	50
#define MAX_NUM_AVG	500

#define RT_MULT		0.0001

#define CMD_IDENTIFY	1
#define CMD_REMOTE	3
#define CMD_STATUS	5
#define CMD_START_MEAS	160
#define CMD_STOP_MEAS	161
#define CMD_READ_LAST	163

#define SER_BUF_LEN		2048
#define RESP_LEN 80	//max length of response message
#define CMD_LEN 80	//max length of command
#define SHORT_RESP_LEN 80	//max length of short response message

#define LF     10
#define CR     13

#define SL_RAW        0     /* raw read/write mode */
#define SL_NCHAR      1     /* character read/write mode */
#define SL_LINE       2     /* line read mode */
#define SL_RETRY      3     /* retry read mode */

#define NUM_STAT 13	//mumber of bit for states description
#define NUM_ERR 15	//mumber of different errors 

#define M_U_WATT	"W"	//measure unit watt
#define M_U_DBM		"DBM"	//measure unit dBm

#define RFSH_POWER_INTVL	50//refresh interval for power/energy measure in ms
#define TIME_WAIT_RECONNECT	5//time in sec between connection establishment retries

#define PA_CIRC_LEN 200		//length of the circular power array (<500)


enum {	
	ID_ERR = 0,
	ID_STAT,
	ID_UNIT,
	ID_PULSERATE,
	ID_BATCHSIZE,
	ID_WAVECORR,
	ID_TRIGSOUR,
	ID_SAMPLERATEPULSE,
	ID_AUTORANGE,
	ID_RANGE,
	ID_GAINFACT,
//	ID_ZERO,
	ID_WAVELIST,
	ID_WAVE,
	ID_TRIGLEV,
	ID_TRIGSLOP,
	ID_TRIGDEL,
	ID_POWMODE,
	ID_LAST
};

namespace LabmaxTop_ns
{


#if 0
static char cmd[][187] = {
"",
"*IDN?",
"*RST",
"SYSTem:REMote",
"SYSTem:LOCal",
"SYSTem:STATus?",
"DISPlay:BACKlight",
"DISPlay:BACKlight?",
"SYSTem:OPTion:BAClightAOFF:ACPower",
"SYSTem:OPTion:BACKlight:AOFF:ACPower?",
"SYSTem:OPTion:BACKlight:AOFF:BPOWer",
"SYSTem:OPTion:BACKlightAOFF:BPOWer?",
"SYSTem:OPTion:POWer:AOFF",
"SYSTem:OPTion:POWer:AOFF?",
"MEMory:STATe:CATalog?",
"MEMory:STATe:SAVE",
"MEMory:STATe:RECall",
"MEMory:STATe:DELete",
"MEMory:STATe:REName",
"SYSTem:COMMunicate:INTerface",
"SYSTem:COMMunicate:INTerface?",
"SYSTem:COMMunicate:HANDshaking",
"SYSTem:COMMunicate:HANDshaking?",
"SYSTem:COMMunicate:SERial:BAUD",
"SYSTem:COMMunicate:SERial:BAUD?",
"SYSTem:COMMunicate:SERial:PARity",
"SYSTem:COMMunicate:SERial:PARity?",
"SYSTem:COMMunicate:SERial:SBITs",
"SYSTem:COMMunicate:SERia1:SBITs?",
"SYSTem:COMMunicate:SERial:PACE",
"SYSTem:COMMunicate:SERial:PACE?",
"SYSTem:COMMunicate:SERial:SERVice",
"SYSTem:COMMunicate:SERial:SERVice?",
"SYSTem:COMMunicate:USB:STRBam",
"SYSTem:COMMunicate:USB:STREam?",
"SYSTem:ERRor:COUNT?",
"SYSTem:ERRar:NEXT?",
"SYSTem:ERRor:ALL?",
"SYSTem:ERRor:CLEar",
"CONFigure:MEASure",
"CONFigure:MEASure?",
"CONFigure:PUNits",
"CONFigure:PUNits?",
"CONFigure:DISPlay:PRlmary",
"CONFigure:DISPlay:STATistics",
"CONFigure:DISPlay:PSTability",
"CONFigure:DISPlay:TUNE",
"CONFigure:DISPlay:TRENd",
"CONFigure:STATistics:DSMode",
"CONFigure:STATistics:DSMode?",
"CONFigure:TRENd:DSMode",
"CONFigure:TRENd:DSMode?",
"CONFigure:PSTability:VMOde",
"CONFigure:PSTability:VMOde?",
"CONFigure:TUNE:VMOde",
"CONFigure:TUNE:VMOde?",
"CONFigure:TREND:VMOde",
"CONFigure:TREND:VMOde?",
"CONFigure:AREA:CORRection",
"CONFigure:AREA:CORRection?",
"CONFigure:AREA:APERture",
"CONFigure:AREA:APERture?",
"CONFigure:AOUT:FSCale",
"CONFigure:AOUT:FSCale?",
"CONFigure:SPEedup:HOST",
"CONFigure:SPEedup:HOST?",
"CONFigure:SPEedup:AOUT",
"CONFigure:SPEedup:AOUT?",
"CONFigure:SPEedup:DISPlay",
"CONFigure:SPEedup:DISPlay?",
"CONFigure:SPEedup:TUNE",
"CONFigure:SPEedup:TUNE?",
"CONFigure:AVERage:PULSe",
"CONFigure:AVERage:PULSe?",
"CONFigure:AVERage:TIME",
"CONFigure:AVERage:TIME?",
"WAVElength:CORRection",
"WAVElength:CORRection?",
"CONFigure:WAVElength:WAVElength",
"CONFigure:WAVElength:WAVElength?",
"CONFigure:WAVElength:LIST",
"CONFigure:WAVElength:LIST?",
"GAIN:COMPensation",
"GAIN:COMPensat?on?",
"CONFigure:ZERO",
"CONFigure:ZERO?",
"CONFigure:RANGe:SELect",
"CONFigure:RANGe:SELect?",
"CONFigure:RANGe:AUTO",
"CONFigure:RANGe:AUTO?",
"CONFigure:STATisties:DISPlay",
"CONFigure:STATistics:DISPlay?",
"CONFigure:STATistics:BSIZe:PULSe",
"CONFigure:STATistics:BSIZe:PULSe?",
"CONFigure:STATistics:BSIZe:TIME",
"CONFigure:STATistics:BSIZe:TIME?",
"CONFigure:STATistics:RATE:PULSe",
"CONFigure:STATistics:RATE:PULSe?",
"CONFigure:STATistics:RATE:FREQuency",
"CONFigure:STATistics:RATE:FREQuency?",
"CONFigure:STATistics:RMOde",
"CONFigure:STATistics:RMOde?",
"CONFigure:STATistics:STARt",
"CONFigure:STATistics:STOP",
"CONFigure:PSTability:DURation",
"CONFigure:PSTability:DURation?",
"PSTability:STARt",
"CONFigure:PSTability:STOP",
"TUNE:SCHart:ZOOM:VERTical",
"TUNE:SCHart:ZOOM:VERTical?",
"CONFigure:TUNE:SCHart:ZOOM:HORizontal",
"CONFigure:TUNE:SCHart:ZOOM:HORizontal?",
"CONFigure:TUNE:BCHart:ZOOM",
"CONFigure:TUNE:BCHart:ZOOM?",
"CONFigure:TUNE:CLEar",
"TRENd:STARt",
"CONFigure:TRENd:STOP",
"TRENd:SCRoll:ZOOM:VERTical",
"TRENd:SCRoll:ZOOM:VERTical?",
"CONFigure:TRENd:BSIZe:PULSe",
"CONFigure:TRENd:BSIZe:PULSe?",
"CONFigure:TRENd:BSIZe:TIME",
"CONFigure:TRENd:BSIZe:TIME.",
"CONFigure:TRENd:RATE:PULSe",
"CONFigure:TRENd:RATE:PULSe?",
"CONFigure:TRENd:RATE:FREQuency",
"CONFigure:TRENd:RATE:FREQuency?",
"MMEMory:CATalog?",
"MMEMory:CDIRectory",
"MMEMory:CDIRectory?",
"MMEMory:MDIRectory",
"MMEMory:DELete",
"MMEMory:RDIRectory",
"MMEMory:REName",
"MMEMory:COPY",
"MMEMory:STORe",
"MMEMory:NAME",
"MMEMory:OPEN",
"MMEMory:FETCh:NRECords?",
"MMEMory:FETCh:NEXT?",
"MMEMory:FETCh:ALL?",
"MMEMory:CLOSE",
"CONFigure:READings:SEND",
"CONFigure:READings:SEND?",
"CONFigure:READings:HEADers",
"CONFigure:READings:HEADers?",
"TRIGger:SOURee",
"TRIGger:SOURee?",
"TRIGger:LEVel",
"TRIGger:LEVel?",
"TRIGger:SLOPe",
"TRIGger:SLOPe?",
"TRIGger:DELay",
"TRIGger:DELay?",
"CONFigure:RESolution:THERmopile",
"CONFigure:RESolution:THERmopile?",
"CONFigure:RESolution:OPTieal",
"CONFigure:RESolution:OPTieal?",
"CONFigure:RESolution:PYRoeleetrie",
"CONFigure:RESolution:PYRoelectric?",
"INITiate",
"ABORt",
"FETCh:NRECords?",
"FETCh:NEXT?",
"FETCh:ALL?",
"FETCh:MISSing?",
"CONFigure:READings:CONTinuous",
"CONFigure:READings:CONTinuous?",
"DISPlay:CONTrast",
"DISPlay:CONTrast?",
"DISPlay:TEXT",
"DISPlay:CLEar",
"SYSTem:TIME",
"SYSTem:TIME?",
"SYSTem:DATE",
"SYSTem:DATE?",
"SYSTem:DATE:FORMat",
"SYSTem:DATE:FORMat?",
"SYSTem:INFormation:INSTrument:SNUMber?",
"SYSTem:INFormation:INSTrument:CDATe?",
"SYSTem:INFormation:INSTrumentTYPE?",
"SYSTem:INFormation:PROBe:TYPE?",
"SYSTem:INFormation:PROBe:MODel?",
"SYSTem:INFormation:PROBe:SNUMber?",
"SYSTem:INFormation:PROBe:RESPonsivity?",
"SYSTem:INFormation:PROBe:CDATe?",
"SYSTem:INFormation:PROBe:TEMPerature?",
"SYSTem:INFormation:PROBe:DIAMeter?"
};


static char* status_desc[NUM_STAT] = {
"Battery is low",
"Sensor damage temperature is exceeded",
"Valid sensor is attached",
"USB flash drive is attached",
"Pyroelectic autoset is in progress",
"Batch data collection is in progress",
"Trend data collection is in progress",
"Meter power is on",
"Future use",
"Data logging to flash active",
"Data logging to in-memory FIFO archive",
"Remote mode enabled",
"Host file copy in progress"
};

static int hex_reg[NUM_STAT] = {
0x00001,
0x00002,
0x00004,
0x00008,
0x00010,
0x00020,
0x00040,
0x00080,
0x00100,
0x00200,
0x00400,
0x00800,
0x01000
};

static char* error_desc[NUM_ERR] = {
"Battery is low",
"Sensor damage temperature is exceeded",
"Valid sensor is attached",
"USB flash drive is attached",
"Pyroelectic autoset is in progress",
"Batch data collection is in progress",
"Trend data collection is in progress",
"Meter power is on",
"Future use",
"Data logging to flash active",
"Data logging to in-memory FIFO archive",
"Remote mode enabled",
"Data logging to in-memory FIFO archive",
"Remote mode enabled",
"Host file copy in progress"
};

static int err_code[NUM_ERR] = {
-350,
-321,
-310,
-254,
-200,
0,
100,
101,
200,
201,
202,
203,
204,
205,
206
};
#endif

/**
 * Class Description:
 * Tango device server for LabMaxTOP laser power/energy meter
 */

/*
 *	Device States Description:
*  Tango::ON :       Device is collecting data
*  Tango::FAULT :    No connection available, device not responding
*  Tango::STANDBY :  Device connected, measurement disabled
 */


class LabmaxTop: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevDouble	*attr_Power_energy_read;
		Tango::DevString	*attr_Info_dev_read;
		Tango::DevString	*attr_Info_status_read;
		Tango::DevString	*attr_Info_error_read;
		Tango::DevString	*attr_Meas_unit_read;
		Tango::DevString	attr_Meas_unit_write;
		Tango::DevBoolean	*attr_Remote_mode_read;
		Tango::DevBoolean	attr_Remote_mode_write;
		Tango::DevString	*attr_Info_probe_read;
		Tango::DevBoolean	*attr_Display_light_read;
		Tango::DevBoolean	attr_Display_light_write;
		Tango::DevDouble	*attr_Zero_read;
		Tango::DevDouble	attr_Zero_write;
		Tango::DevDouble	*attr_Range_read;
		Tango::DevDouble	attr_Range_write;
		Tango::DevBoolean	*attr_Auto_range_read;
		Tango::DevBoolean	attr_Auto_range_write;
		Tango::DevBoolean	*attr_Gain_comp_read;
		Tango::DevBoolean	attr_Gain_comp_write;
		Tango::DevLong	*attr_Wavelength_read;
		Tango::DevLong	attr_Wavelength_write;
		Tango::DevString	*attr_Trigger_param_read;
		Tango::DevString	attr_Trigger_param_write;
		Tango::DevString	*attr_Power_mode_read;
		Tango::DevString	attr_Power_mode_write;
		Tango::DevString	*attr_Info_comm_read;
		Tango::DevString	attr_Info_comm_write;
		Tango::DevString	*attr_Sub_unit_read;
		Tango::DevLong	*attr_Batch_size_pulse_read;
		Tango::DevLong	attr_Batch_size_pulse_write;
		Tango::DevLong	*attr_Sampl_rate_pulse_read;
		Tango::DevLong	attr_Sampl_rate_pulse_write;
		Tango::DevFloat	*attr_Sampl_rate_time_read;
		Tango::DevFloat	attr_Sampl_rate_time_write;
		Tango::DevString	*attr_Batch_size_time_read;
		Tango::DevString	attr_Batch_size_time_write;
		Tango::DevDouble	*attr_Mean_read;
		Tango::DevDouble	*attr_Std_dev_read;
		Tango::DevDouble	*attr_Max_read;
		Tango::DevDouble	*attr_Min_read;
		Tango::DevDouble	*attr_Gain_factor_read;
		Tango::DevDouble	attr_Gain_factor_write;
		Tango::DevBoolean	*attr_Area_corr_read;
		Tango::DevBoolean	attr_Area_corr_write;
		Tango::DevDouble	*attr_Aperture_area_read;
		Tango::DevDouble	attr_Aperture_area_write;
		Tango::DevShort	*attr_Out_volt_fscale_read;
		Tango::DevShort	attr_Out_volt_fscale_write;
		Tango::DevBoolean	*attr_Wlen_correction_read;
		Tango::DevBoolean	attr_Wlen_correction_write;
		Tango::DevString	*attr_Wlen_list_read;
		Tango::DevString	attr_Wlen_list_write;
		Tango::DevString	*attr_Trig_source_int_read;
		Tango::DevString	attr_Trig_source_int_write;
		Tango::DevShort	*attr_Trig_int_lev_read;
		Tango::DevShort	attr_Trig_int_lev_write;
		Tango::DevString	*attr_Trig_ext_pos_read;
		Tango::DevString	attr_Trig_ext_pos_write;
		Tango::DevShort	*attr_Trig_ext_del_read;
		Tango::DevShort	attr_Trig_ext_del_write;
		Tango::DevLong	*attr_Duration_read;
		Tango::DevLong	attr_Duration_write;
		Tango::DevLong	*attr_Pulse_freq_read;
		Tango::DevShort	*attr_Pw_idx_read;
		Tango::DevDouble	*attr_Pw_inst_read;
		Tango::DevLong	*attr_Pw_nrec_read;
		Tango::DevDouble	*attr_Correction_factor_read;
		Tango::DevDouble	attr_Correction_factor_write;
		Tango::DevDouble	*attr_Correction_offset_read;
		Tango::DevDouble	attr_Correction_offset_write;
		Tango::DevDouble	*attr_Corrected_energy_read;
		Tango::DevBoolean	*attr_Rt_mode_read;
		Tango::DevBoolean	attr_Rt_mode_write;
		Tango::DevBoolean	*attr_Rt_data_stat_read;
		Tango::DevLong	*attr_Rt_data_count_read;
		Tango::DevBoolean	*attr_Correction_on_read;
		Tango::DevBoolean	attr_Correction_on_write;
		Tango::DevLong	*attr_Num_avg_read;
		Tango::DevLong	attr_Num_avg_write;
		Tango::DevDouble	*attr_Pw_buf_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	Tango device server for low level communication:
 *	serial or USB e.g.:
 *	ken/tty/0
 */
	string	interface;
/**
 *	
 */
	Tango::DevBoolean	debug_mode;
/**
 *	
 */
	Tango::DevShort	pwr_rfsh;
/**
 *	-correction factor
 *	-offset
 */
	vector<double>	correction;
/**
 *	
 */
//	string	rTBufferdevice;
/**
 *	
 */
//	string	rTLabmaxtopdevice;
/**
 *	
 */
	Tango::DevShort	rTSleep;
/**
 *	
 */
	Tango::DevLong	rTArraysize;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	LabmaxTop(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	LabmaxTop(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	LabmaxTop(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~LabmaxTop() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name LabmaxTop methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Power_energy acquisition result.
 */
	virtual void read_Power_energy(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Info_dev acquisition result.
 */
	virtual void read_Info_dev(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Info_status acquisition result.
 */
	virtual void read_Info_status(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Info_error acquisition result.
 */
	virtual void read_Info_error(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Meas_unit acquisition result.
 */
	virtual void read_Meas_unit(Tango::Attribute &attr);
/**
 *	Write Meas_unit attribute values to hardware.
 */
	virtual void write_Meas_unit(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Remote_mode acquisition result.
 */
	virtual void read_Remote_mode(Tango::Attribute &attr);
/**
 *	Write Remote_mode attribute values to hardware.
 */
	virtual void write_Remote_mode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Info_probe acquisition result.
 */
	virtual void read_Info_probe(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Display_light acquisition result.
 */
	virtual void read_Display_light(Tango::Attribute &attr);
/**
 *	Write Display_light attribute values to hardware.
 */
	virtual void write_Display_light(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Zero acquisition result.
 */
	virtual void read_Zero(Tango::Attribute &attr);
/**
 *	Write Zero attribute values to hardware.
 */
	virtual void write_Zero(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Range acquisition result.
 */
	virtual void read_Range(Tango::Attribute &attr);
/**
 *	Write Range attribute values to hardware.
 */
	virtual void write_Range(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Auto_range acquisition result.
 */
	virtual void read_Auto_range(Tango::Attribute &attr);
/**
 *	Write Auto_range attribute values to hardware.
 */
	virtual void write_Auto_range(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Gain_comp acquisition result.
 */
	virtual void read_Gain_comp(Tango::Attribute &attr);
/**
 *	Write Gain_comp attribute values to hardware.
 */
	virtual void write_Gain_comp(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Wavelength acquisition result.
 */
	virtual void read_Wavelength(Tango::Attribute &attr);
/**
 *	Write Wavelength attribute values to hardware.
 */
	virtual void write_Wavelength(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Trigger_param acquisition result.
 */
	virtual void read_Trigger_param(Tango::Attribute &attr);
/**
 *	Write Trigger_param attribute values to hardware.
 */
	virtual void write_Trigger_param(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Power_mode acquisition result.
 */
	virtual void read_Power_mode(Tango::Attribute &attr);
/**
 *	Write Power_mode attribute values to hardware.
 */
	virtual void write_Power_mode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Info_comm acquisition result.
 */
	virtual void read_Info_comm(Tango::Attribute &attr);
/**
 *	Write Info_comm attribute values to hardware.
 */
	virtual void write_Info_comm(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Sub_unit acquisition result.
 */
	virtual void read_Sub_unit(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Batch_size_pulse acquisition result.
 */
	virtual void read_Batch_size_pulse(Tango::Attribute &attr);
/**
 *	Write Batch_size_pulse attribute values to hardware.
 */
	virtual void write_Batch_size_pulse(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Sampl_rate_pulse acquisition result.
 */
	virtual void read_Sampl_rate_pulse(Tango::Attribute &attr);
/**
 *	Write Sampl_rate_pulse attribute values to hardware.
 */
	virtual void write_Sampl_rate_pulse(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Sampl_rate_time acquisition result.
 */
	virtual void read_Sampl_rate_time(Tango::Attribute &attr);
/**
 *	Write Sampl_rate_time attribute values to hardware.
 */
	virtual void write_Sampl_rate_time(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Batch_size_time acquisition result.
 */
	virtual void read_Batch_size_time(Tango::Attribute &attr);
/**
 *	Write Batch_size_time attribute values to hardware.
 */
	virtual void write_Batch_size_time(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Mean acquisition result.
 */
	virtual void read_Mean(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Std_dev acquisition result.
 */
	virtual void read_Std_dev(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Max acquisition result.
 */
	virtual void read_Max(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Min acquisition result.
 */
	virtual void read_Min(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Gain_factor acquisition result.
 */
	virtual void read_Gain_factor(Tango::Attribute &attr);
/**
 *	Write Gain_factor attribute values to hardware.
 */
	virtual void write_Gain_factor(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Area_corr acquisition result.
 */
	virtual void read_Area_corr(Tango::Attribute &attr);
/**
 *	Write Area_corr attribute values to hardware.
 */
	virtual void write_Area_corr(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Aperture_area acquisition result.
 */
	virtual void read_Aperture_area(Tango::Attribute &attr);
/**
 *	Write Aperture_area attribute values to hardware.
 */
	virtual void write_Aperture_area(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Out_volt_fscale acquisition result.
 */
	virtual void read_Out_volt_fscale(Tango::Attribute &attr);
/**
 *	Write Out_volt_fscale attribute values to hardware.
 */
	virtual void write_Out_volt_fscale(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Wlen_correction acquisition result.
 */
	virtual void read_Wlen_correction(Tango::Attribute &attr);
/**
 *	Write Wlen_correction attribute values to hardware.
 */
	virtual void write_Wlen_correction(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Wlen_list acquisition result.
 */
	virtual void read_Wlen_list(Tango::Attribute &attr);
/**
 *	Write Wlen_list attribute values to hardware.
 */
	virtual void write_Wlen_list(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Trig_source_int acquisition result.
 */
	virtual void read_Trig_source_int(Tango::Attribute &attr);
/**
 *	Write Trig_source_int attribute values to hardware.
 */
	virtual void write_Trig_source_int(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Trig_int_lev acquisition result.
 */
	virtual void read_Trig_int_lev(Tango::Attribute &attr);
/**
 *	Write Trig_int_lev attribute values to hardware.
 */
	virtual void write_Trig_int_lev(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Trig_ext_pos acquisition result.
 */
	virtual void read_Trig_ext_pos(Tango::Attribute &attr);
/**
 *	Write Trig_ext_pos attribute values to hardware.
 */
	virtual void write_Trig_ext_pos(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Trig_ext_del acquisition result.
 */
	virtual void read_Trig_ext_del(Tango::Attribute &attr);
/**
 *	Write Trig_ext_del attribute values to hardware.
 */
	virtual void write_Trig_ext_del(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Duration acquisition result.
 */
	virtual void read_Duration(Tango::Attribute &attr);
/**
 *	Write Duration attribute values to hardware.
 */
	virtual void write_Duration(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Pulse_freq acquisition result.
 */
	virtual void read_Pulse_freq(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Pw_idx acquisition result.
 */
	virtual void read_Pw_idx(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Pw_inst acquisition result.
 */
	virtual void read_Pw_inst(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Pw_nrec acquisition result.
 */
	virtual void read_Pw_nrec(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Correction_factor acquisition result.
 */
	virtual void read_Correction_factor(Tango::Attribute &attr);
/**
 *	Write Correction_factor attribute values to hardware.
 */
	virtual void write_Correction_factor(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Correction_offset acquisition result.
 */
	virtual void read_Correction_offset(Tango::Attribute &attr);
/**
 *	Write Correction_offset attribute values to hardware.
 */
	virtual void write_Correction_offset(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Corrected_energy acquisition result.
 */
	virtual void read_Corrected_energy(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Rt_mode acquisition result.
 */
	virtual void read_Rt_mode(Tango::Attribute &attr);
/**
 *	Write Rt_mode attribute values to hardware.
 */
	virtual void write_Rt_mode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Rt_data_stat acquisition result.
 */
	virtual void read_Rt_data_stat(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Rt_data_count acquisition result.
 */
	virtual void read_Rt_data_count(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Correction_on acquisition result.
 */
	virtual void read_Correction_on(Tango::Attribute &attr);
/**
 *	Write Correction_on attribute values to hardware.
 */
	virtual void write_Correction_on(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Num_avg acquisition result.
 */
	virtual void read_Num_avg(Tango::Attribute &attr);
/**
 *	Write Num_avg attribute values to hardware.
 */
	virtual void write_Num_avg(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Pw_buf acquisition result.
 */
	virtual void read_Pw_buf(Tango::Attribute &attr);
/**
 *	Read/Write allowed for Power_energy attribute.
 */
	virtual bool is_Power_energy_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Info_dev attribute.
 */
	virtual bool is_Info_dev_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Info_status attribute.
 */
	virtual bool is_Info_status_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Info_error attribute.
 */
	virtual bool is_Info_error_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Meas_unit attribute.
 */
	virtual bool is_Meas_unit_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Remote_mode attribute.
 */
	virtual bool is_Remote_mode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Info_probe attribute.
 */
	virtual bool is_Info_probe_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Display_light attribute.
 */
	virtual bool is_Display_light_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Zero attribute.
 */
	virtual bool is_Zero_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Range attribute.
 */
	virtual bool is_Range_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Auto_range attribute.
 */
	virtual bool is_Auto_range_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Gain_comp attribute.
 */
	virtual bool is_Gain_comp_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Wavelength attribute.
 */
	virtual bool is_Wavelength_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Trigger_param attribute.
 */
	virtual bool is_Trigger_param_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Power_mode attribute.
 */
	virtual bool is_Power_mode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Info_comm attribute.
 */
	virtual bool is_Info_comm_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Sub_unit attribute.
 */
	virtual bool is_Sub_unit_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Batch_size_pulse attribute.
 */
	virtual bool is_Batch_size_pulse_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Sampl_rate_pulse attribute.
 */
	virtual bool is_Sampl_rate_pulse_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Sampl_rate_time attribute.
 */
	virtual bool is_Sampl_rate_time_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Batch_size_time attribute.
 */
	virtual bool is_Batch_size_time_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Mean attribute.
 */
	virtual bool is_Mean_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Std_dev attribute.
 */
	virtual bool is_Std_dev_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Max attribute.
 */
	virtual bool is_Max_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Min attribute.
 */
	virtual bool is_Min_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Gain_factor attribute.
 */
	virtual bool is_Gain_factor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Area_corr attribute.
 */
	virtual bool is_Area_corr_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Aperture_area attribute.
 */
	virtual bool is_Aperture_area_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Out_volt_fscale attribute.
 */
	virtual bool is_Out_volt_fscale_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Wlen_correction attribute.
 */
	virtual bool is_Wlen_correction_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Wlen_list attribute.
 */
	virtual bool is_Wlen_list_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Trig_source_int attribute.
 */
	virtual bool is_Trig_source_int_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Trig_int_lev attribute.
 */
	virtual bool is_Trig_int_lev_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Trig_ext_pos attribute.
 */
	virtual bool is_Trig_ext_pos_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Trig_ext_del attribute.
 */
	virtual bool is_Trig_ext_del_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Duration attribute.
 */
	virtual bool is_Duration_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Pulse_freq attribute.
 */
	virtual bool is_Pulse_freq_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Pw_idx attribute.
 */
	virtual bool is_Pw_idx_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Pw_inst attribute.
 */
	virtual bool is_Pw_inst_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Pw_nrec attribute.
 */
	virtual bool is_Pw_nrec_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Correction_factor attribute.
 */
	virtual bool is_Correction_factor_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Correction_offset attribute.
 */
	virtual bool is_Correction_offset_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Corrected_energy attribute.
 */
	virtual bool is_Corrected_energy_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Rt_mode attribute.
 */
	virtual bool is_Rt_mode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Rt_data_stat attribute.
 */
	virtual bool is_Rt_data_stat_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Rt_data_count attribute.
 */
	virtual bool is_Rt_data_count_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Correction_on attribute.
 */
	virtual bool is_Correction_on_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Num_avg attribute.
 */
	virtual bool is_Num_avg_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Pw_buf attribute.
 */
	virtual bool is_Pw_buf_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Async_cmd command.
 */
	virtual bool is_Async_cmd_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Reset command.
 */
	virtual bool is_Reset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Stats_start command.
 */
	virtual bool is_Stats_start_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Stats_stop command.
 */
	virtual bool is_Stats_stop_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Probe_zero command.
 */
	virtual bool is_Probe_zero_allowed(const CORBA::Any &any);
#if 0
/**
 *	Execution allowed for GetPower_energy command.
 */
	virtual bool is_GetPower_energy_allowed(const CORBA::Any &any);
#endif
/**
 * 
 *	@param	argin	command to be sent
 *	@return	response if any
 *	@exception DevFailed
 */
	Tango::DevString	async_cmd(Tango::DevString);
/**
 * 
 *	@exception DevFailed
 */
	void	reset();
/**
 * 
 *	@exception DevFailed
 */
	void	stats_start();
/**
 * 
 *	@exception DevFailed
 */
	void	stats_stop();
/**
 * 
 *	@exception DevFailed
 */
	void	probe_zero();
#if 0
/**
 * 
 *	@param	argin	
 *	@return	
 *	@exception DevFailed
 */
	Tango::DevVarDoubleArray	*get_power_energy(const Tango::DevVarLongArray *);
#endif

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	

	string sendCmd(string, bool);
	string asn_cmd(string argin);

	Tango::DeviceProxy *devinterface;
	int wr_delay;
	int cmd_delay;
	Tango::DevString	usercmd;
	Tango::DevString	userres;
	int abortflag;		//if<0 server is shutting down thread
	int connection_status;	//if<0 connection is lost
	readthread *readloop;
	pwrthread *pwrloop;
	omni_mutex *mutex;
	Tango::DevBoolean pause_read;

//	Tango::DevVarDoubleArray *pa_circ;	//circular power array
	Tango::DevShort p_circ;		//circular power array pointer
	Tango::DevDouble pw_circ_inst;
	Tango::DevDouble	val_double[PA_CIRC_LEN];
	Tango::DevLong nrec;

	Tango::DevBoolean correction_on;
	Tango::DevDouble corrected_energy;
	Tango::DevDouble correction_factor;
	Tango::DevDouble correction_offset;
	Tango::DevLong rt_datacount;
	Tango::DevBoolean rt_datastat;
	Tango::DevBoolean rt_mode;
	Tango::DevLong num_avg;

	Tango::DevDouble power_energy;
	Tango::DevDouble power_energy_corr;
	char meas_unit[10];
	Tango::DevString meas_unit_ptr;
	char	info_status[RESP_LEN];
	Tango::DevString info_status_ptr;
	char 	info_error[RESP_LEN];
	Tango::DevString info_error_ptr;
	
	Tango::DevBoolean remote_mode;
	Tango::DevBoolean display_light;
	Tango::DevDouble zero;
	Tango::DevDouble range;
	Tango::DevBoolean auto_range;

	Tango::DevLong wavelength;
	Tango::DevString trigger_param;
	Tango::DevString power_mode;
	Tango::DevString sub_unit;
	Tango::DevDouble gain_factor;

	Tango::DevBoolean wlen_correction;
	char	wave_list[RESP_LEN];
	char	old_wave_list[RESP_LEN];
	Tango::DevString wave_list_ptr;
	char   trig_source_int[10];
	Tango::DevString trig_source_int_ptr;
	Tango::DevShort trig_int_lev;
	char   trig_ext_pos[10];
	Tango::DevString trig_ext_pos_ptr;
	Tango::DevShort trig_ext_del;
	Tango::DevLong duration;
	Tango::DevLong pulse_freq;
	Tango::DevLong batch_size_pulse;
	Tango::DevLong sampl_rate_pulse;

	char   comm_intfc[RESP_LEN];
	char   comm_baud[RESP_LEN];
	char   comm_par[SHORT_RESP_LEN];
	char   comm_sbit[SHORT_RESP_LEN];
	char   comm_pace[SHORT_RESP_LEN];
	char   comm_serv[SHORT_RESP_LEN];
	char	info_comm[RESP_LEN];
	Tango::DevString info_comm_ptr;
	char	probe_type[SHORT_RESP_LEN];
	char	probe_mod[SHORT_RESP_LEN];
	char	probe_num[SHORT_RESP_LEN];
	char	probe_resp[SHORT_RESP_LEN];
	char	probe_cdat[SHORT_RESP_LEN];
	char	probe_temp[SHORT_RESP_LEN];
	char	probe_diam[SHORT_RESP_LEN];
	char	info_probe[RESP_LEN];
	Tango::DevString info_probe_ptr;
	char	sys_id[SHORT_RESP_LEN];
	char	sys_snum[SHORT_RESP_LEN];
	char	sys_cdat[SHORT_RESP_LEN];
	char	sys_type[SHORT_RESP_LEN];
	char	info_dev[RESP_LEN];
	Tango::DevString info_dev_ptr;

	map<string, float> multipliers;
	Tango::DevBoolean stats_on;
	Tango::DevDouble mean;
	Tango::DevDouble sum;
	Tango::DevDouble sqsum;
	Tango::DevLong nsamples;
	Tango::DevDouble std_dev;
	Tango::DevDouble min;
	Tango::DevDouble max;

//real time
//	labmaxtop_shm_t *labmaxtop;
//	int fd_buffer;
	int rate;

protected :	
	//	Add your own data members here
	//-----------------------------------------
	Tango::DevBoolean sz_debug;
	
//	struct _buffer *buf;
	long vsize;
//	void check_get_data_param(const Tango::DevVarLongArray *, long *, long *);
	void abort_sleep(double time); 
};

}	// namespace_ns

#endif	// _LABMAXTOP_H
