static const char *RcsId     = "";
static const char *TagName   = "";
static const char *HttpServer= "";
//+=============================================================================
//
// file :        LabmaxTopClass.cpp
//
// description : C++ source for the LabmaxTopClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the LabmaxTop once per process.
//
// project :     TANGO Device Server
//
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <LabmaxTop.h>
#include <LabmaxTopClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create LabmaxTopClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_LabmaxTop_class(const char *name) {
		return LabmaxTop_ns::LabmaxTopClass::init(name);
	}
}


namespace LabmaxTop_ns
{
#if 0
//+----------------------------------------------------------------------------
//
// method : 		GetPower_energyClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetPower_energyClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetPower_energyClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<LabmaxTop *>(device))->get_power_energy(argin));
}
#endif

//+----------------------------------------------------------------------------
//
// method : 		Probe_zeroClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Probe_zeroClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Probe_zeroClass::execute(): arrived" << endl;

	((static_cast<LabmaxTop *>(device))->probe_zero());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Stats_stopClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Stats_stopClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Stats_stopClass::execute(): arrived" << endl;

	((static_cast<LabmaxTop *>(device))->stats_stop());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Stats_startClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Stats_startClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Stats_startClass::execute(): arrived" << endl;

	((static_cast<LabmaxTop *>(device))->stats_start());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		ResetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ResetClass::execute(): arrived" << endl;

	((static_cast<LabmaxTop *>(device))->reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Async_cmdClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Async_cmdClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Async_cmdClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	return insert((static_cast<LabmaxTop *>(device))->async_cmd(argin));
}



//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
LabmaxTopClass *LabmaxTopClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::LabmaxTopClass(string &s)
// 
// description : 	constructor for the LabmaxTopClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
LabmaxTopClass::LabmaxTopClass(string &s):DeviceClass(s)
{

	cout2 << "Entering LabmaxTopClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving LabmaxTopClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::~LabmaxTopClass()
// 
// description : 	destructor for the LabmaxTopClass
//
//-----------------------------------------------------------------------------
LabmaxTopClass::~LabmaxTopClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
LabmaxTopClass *LabmaxTopClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new LabmaxTopClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

LabmaxTopClass *LabmaxTopClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void LabmaxTopClass::command_factory()
{
	command_list.push_back(new Async_cmdClass("Async_cmd",
		Tango::DEV_STRING, Tango::DEV_STRING,
		"command to be sent",
		"response if any",
		Tango::OPERATOR));
	command_list.push_back(new ResetClass("Reset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Stats_startClass("Stats_start",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Stats_stopClass("Stats_stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Probe_zeroClass("Probe_zero",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
#if 0
	command_list.push_back(new GetPower_energyClass("GetPower_energy",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
#endif

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum LabmaxTopClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum LabmaxTopClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum LabmaxTopClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void LabmaxTopClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new LabmaxTop(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: LabmaxTopClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void LabmaxTopClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Power_energy
	Power_energyAttrib	*power_energy = new Power_energyAttrib();
	att_list.push_back(power_energy);

	//	Attribute : Info_dev
	Info_devAttrib	*info_dev = new Info_devAttrib();
	att_list.push_back(info_dev);

	//	Attribute : Info_status
	Info_statusAttrib	*info_status = new Info_statusAttrib();
	att_list.push_back(info_status);

	//	Attribute : Info_error
	Info_errorAttrib	*info_error = new Info_errorAttrib();
	att_list.push_back(info_error);
	
	//	Attribute : Rt_mode
	Rt_modeAttrib	*rt_mode = new Rt_modeAttrib();
	att_list.push_back(rt_mode);

	//	Attribute : Rt_data_stat
	Rt_data_statAttrib	*rt_data_stat = new Rt_data_statAttrib();
	att_list.push_back(rt_data_stat);

	//	Attribute : Rt_data_count
	Rt_data_countAttrib	*rt_data_count = new Rt_data_countAttrib();
	att_list.push_back(rt_data_count);

	//	Attribute : Correction_on
	Correction_onAttrib	*correction_on = new Correction_onAttrib();
	att_list.push_back(correction_on);
	
	//	Attribute : Correction_factor
	Correction_factorAttrib	*correction_factor = new Correction_factorAttrib();
	att_list.push_back(correction_factor);

	//	Attribute : Correction_offset
	Correction_offsetAttrib	*correction_offset = new Correction_offsetAttrib();
	att_list.push_back(correction_offset);

	//	Attribute : Pulse_freq
	Pulse_freqAttrib	*pulse_freq = new Pulse_freqAttrib();
	att_list.push_back(pulse_freq);

	//	Attribute : Auto_range
	Auto_rangeAttrib	*auto_range = new Auto_rangeAttrib();
	att_list.push_back(auto_range);
	
	//	Attribute : Range
	RangeAttrib	*range = new RangeAttrib();
	att_list.push_back(range);
	
	//	Attribute : Info_probe
	Info_probeAttrib	*info_probe = new Info_probeAttrib();
	att_list.push_back(info_probe);

	//	Attribute : Power_mode
	Power_modeAttrib	*power_mode = new Power_modeAttrib();
	att_list.push_back(power_mode);

	//	Attribute : Meas_unit
	Meas_unitAttrib	*meas_unit = new Meas_unitAttrib();
	
	//	Attribute : Sub_unit
	Sub_unitAttrib	*sub_unit = new Sub_unitAttrib();
	att_list.push_back(sub_unit);

	//	Attribute : Info_comm
	Info_commAttrib	*info_comm = new Info_commAttrib();
	att_list.push_back(info_comm);

	//	Attribute : Num_avg
	Num_avgAttrib	*num_avg = new Num_avgAttrib();
	att_list.push_back(num_avg);

	//	Attribute : Mean
	MeanAttrib	*mean = new MeanAttrib();
	att_list.push_back(mean);

	//	Attribute : Std_dev
	Std_devAttrib	*std_dev = new Std_devAttrib();
	att_list.push_back(std_dev);

	//	Attribute : Max
	MaxAttrib	*max = new MaxAttrib();
	att_list.push_back(max);

	//	Attribute : Min
	MinAttrib	*min = new MinAttrib();
	att_list.push_back(min);

	//	Attribute : Wlen_correction
	Wlen_correctionAttrib	*wlen_correction = new Wlen_correctionAttrib();
	att_list.push_back(wlen_correction);

	//	Attribute : Wavelength
	WavelengthAttrib	*wavelength = new WavelengthAttrib();
	att_list.push_back(wavelength);
	
	//	Attribute : Wlen_list
	Wlen_listAttrib	*wlen_list = new Wlen_listAttrib();
	att_list.push_back(wlen_list);

	//	Attribute : Trig_source_int
	Trig_source_intAttrib	*trig_source_int = new Trig_source_intAttrib();
	att_list.push_back(trig_source_int);

	//	Attribute : Trig_int_lev
	Trig_int_levAttrib	*trig_int_lev = new Trig_int_levAttrib();
	att_list.push_back(trig_int_lev);

	//	Attribute : Trig_ext_pos
	Trig_ext_posAttrib	*trig_ext_pos = new Trig_ext_posAttrib();
	att_list.push_back(trig_ext_pos);

	//	Attribute : Trig_ext_del
	Trig_ext_delAttrib	*trig_ext_del = new Trig_ext_delAttrib();
	att_list.push_back(trig_ext_del);

	//	Attribute : Sampl_rate_pulse
	Sampl_rate_pulseAttrib	*sampl_rate_pulse = new Sampl_rate_pulseAttrib();
	att_list.push_back(sampl_rate_pulse);

	
	//	Attribute : Corrected_energy
	Corrected_energyAttrib	*corrected_energy = new Corrected_energyAttrib();
	att_list.push_back(corrected_energy);
	
#if 0
	
	//	Attribute : Gain_factor
	Gain_factorAttrib	*gain_factor = new Gain_factorAttrib();
	att_list.push_back(gain_factor);
	
	//	Attribute : Batch_size_pulse
	Batch_size_pulseAttrib	*batch_size_pulse = new Batch_size_pulseAttrib();
	att_list.push_back(batch_size_pulse);
	
	//	Attribute : Zero
	ZeroAttrib	*zero = new ZeroAttrib();
	att_list.push_back(zero);
	
	//	Attribute : Duration
	DurationAttrib	*duration = new DurationAttrib();
	att_list.push_back(duration);
	
	//	Attribute : Gain_comp
	Gain_compAttrib	*gain_comp = new Gain_compAttrib();
	att_list.push_back(gain_comp);
	
	//	Attribute : Area_corr
	Area_corrAttrib	*area_corr = new Area_corrAttrib();
	att_list.push_back(area_corr);

	//	Attribute : Aperture_area
	Aperture_areaAttrib	*aperture_area = new Aperture_areaAttrib();
	att_list.push_back(aperture_area);

	//	Attribute : Out_volt_fscale
	Out_volt_fscaleAttrib	*out_volt_fscale = new Out_volt_fscaleAttrib();
	att_list.push_back(out_volt_fscale);

	//	Attribute : Batch_size_time
	Batch_size_timeAttrib	*batch_size_time = new Batch_size_timeAttrib();
	att_list.push_back(batch_size_time);

	//	Attribute : Sampl_rate_time
	Sampl_rate_timeAttrib	*sampl_rate_time = new Sampl_rate_timeAttrib();
	att_list.push_back(sampl_rate_time);

//#if 0	
	//	Attribute : Pw_idx
	Pw_idxAttrib	*pw_idx = new Pw_idxAttrib();
	att_list.push_back(pw_idx);

	//	Attribute : Pw_inst
	Pw_instAttrib	*pw_inst = new Pw_instAttrib();
	att_list.push_back(pw_inst);

	//	Attribute : Pw_nrec
	Pw_nrecAttrib	*pw_nrec = new Pw_nrecAttrib();
	att_list.push_back(pw_nrec);

	//	Attribute : Pw_buf
	Pw_bufAttrib	*pw_buf = new Pw_bufAttrib();
	att_list.push_back(pw_buf);	
	
	//	Attribute : Trigger_param
	Trigger_paramAttrib	*trigger_param = new Trigger_paramAttrib();
	att_list.push_back(trigger_param);
	
	//	Attribute : Remote_mode
	Remote_modeAttrib	*remote_mode = new Remote_modeAttrib();
	att_list.push_back(remote_mode);
	
	//	Attribute : Display_light
	Display_lightAttrib	*display_light = new Display_lightAttrib();
	att_list.push_back(display_light);
#endif
	
	//	End of Automatic code generation
	//-------------------------------------------------------------
}



//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void LabmaxTopClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	LabmaxTopClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void LabmaxTopClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Interface";
	prop_desc = "Tango device server for low level communication:\nserial or USB e.g.:\nken/tty/0";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Debug_mode";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Pwr_rfsh";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Correction";
	prop_desc = "-correction factor\n-offset";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTBufferdevice";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTLabmaxtopdevice";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTSleep";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RTArraysize";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		LabmaxTopClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void LabmaxTopClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("LabMaxTOP");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Tango device server for LabMaxTOP laser power/energy meter");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
