//=============================================================================
//
// file :         LabmaxTopClass.h
//
// description :  Include for the LabmaxTopClass root class.
//                This class is represents the singleton class for
//                the LabmaxTop device class.
//                It contains all properties and methods which the 
//                LabmaxTop requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _LABMAXTOPCLASS_H
#define _LABMAXTOPCLASS_H

#include <tango.h>
#include <LabmaxTop.h>


namespace LabmaxTop_ns
{//=====================================
//=====================================
//	Define classes for attributes
//=====================================
class Pw_bufAttrib: public Tango::SpectrumAttr
{
public:
	Pw_bufAttrib():SpectrumAttr("Pw_buf", Tango::DEV_DOUBLE, Tango::READ, 500) {};
	~Pw_bufAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Pw_buf(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Pw_buf_allowed(ty);}
};

class Num_avgAttrib: public Tango::Attr
{
public:
	Num_avgAttrib():Attr("Num_avg", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Num_avgAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Num_avg(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Num_avg(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Num_avg_allowed(ty);}
};

class Correction_onAttrib: public Tango::Attr
{
public:
	Correction_onAttrib():Attr("Correction_on", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Correction_onAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Correction_on(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Correction_on(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Correction_on_allowed(ty);}
};

class Rt_data_countAttrib: public Tango::Attr
{
public:
	Rt_data_countAttrib():Attr("Rt_data_count", Tango::DEV_LONG, Tango::READ) {};
	~Rt_data_countAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Rt_data_count(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Rt_data_count_allowed(ty);}
};

class Rt_data_statAttrib: public Tango::Attr
{
public:
	Rt_data_statAttrib():Attr("Rt_data_stat", Tango::DEV_BOOLEAN, Tango::READ) {};
	~Rt_data_statAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Rt_data_stat(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Rt_data_stat_allowed(ty);}
};

class Rt_modeAttrib: public Tango::Attr
{
public:
	Rt_modeAttrib():Attr("Rt_mode", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Rt_modeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Rt_mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Rt_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Rt_mode_allowed(ty);}
};

class Corrected_energyAttrib: public Tango::Attr
{
public:
	Corrected_energyAttrib():Attr("Corrected_energy", Tango::DEV_DOUBLE, Tango::READ) {};
	~Corrected_energyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Corrected_energy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Corrected_energy_allowed(ty);}
};

class Correction_offsetAttrib: public Tango::Attr
{
public:
	Correction_offsetAttrib():Attr("Correction_offset", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Correction_offsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Correction_offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Correction_offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Correction_offset_allowed(ty);}
};

class Correction_factorAttrib: public Tango::Attr
{
public:
	Correction_factorAttrib():Attr("Correction_factor", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Correction_factorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Correction_factor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Correction_factor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Correction_factor_allowed(ty);}
};

class Pw_nrecAttrib: public Tango::Attr
{
public:
	Pw_nrecAttrib():Attr("Pw_nrec", Tango::DEV_LONG, Tango::READ) {};
	~Pw_nrecAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Pw_nrec(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Pw_nrec_allowed(ty);}
};

class Pw_instAttrib: public Tango::Attr
{
public:
	Pw_instAttrib():Attr("Pw_inst", Tango::DEV_DOUBLE, Tango::READ) {};
	~Pw_instAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Pw_inst(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Pw_inst_allowed(ty);}
};

class Pw_idxAttrib: public Tango::Attr
{
public:
	Pw_idxAttrib():Attr("Pw_idx", Tango::DEV_SHORT, Tango::READ) {};
	~Pw_idxAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Pw_idx(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Pw_idx_allowed(ty);}
};

class Pulse_freqAttrib: public Tango::Attr
{
public:
	Pulse_freqAttrib():Attr("Pulse_freq", Tango::DEV_LONG, Tango::READ) {};
	~Pulse_freqAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Pulse_freq(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Pulse_freq_allowed(ty);}
};

class DurationAttrib: public Tango::Attr
{
public:
	DurationAttrib():Attr("Duration", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DurationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Duration(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Duration(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Duration_allowed(ty);}
};

class Trig_ext_delAttrib: public Tango::Attr
{
public:
	Trig_ext_delAttrib():Attr("Trig_ext_del", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Trig_ext_delAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Trig_ext_del(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Trig_ext_del(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Trig_ext_del_allowed(ty);}
};

class Trig_ext_posAttrib: public Tango::Attr
{
public:
	Trig_ext_posAttrib():Attr("Trig_ext_pos", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Trig_ext_posAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Trig_ext_pos(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Trig_ext_pos(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Trig_ext_pos_allowed(ty);}
};

class Trig_int_levAttrib: public Tango::Attr
{
public:
	Trig_int_levAttrib():Attr("Trig_int_lev", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Trig_int_levAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Trig_int_lev(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Trig_int_lev(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Trig_int_lev_allowed(ty);}
};

class Trig_source_intAttrib: public Tango::Attr
{
public:
	Trig_source_intAttrib():Attr("Trig_source_int", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Trig_source_intAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Trig_source_int(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Trig_source_int(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Trig_source_int_allowed(ty);}
};

class Wlen_listAttrib: public Tango::Attr
{
public:
	Wlen_listAttrib():Attr("Wlen_list", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Wlen_listAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Wlen_list(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Wlen_list(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Wlen_list_allowed(ty);}
};

class Wlen_correctionAttrib: public Tango::Attr
{
public:
	Wlen_correctionAttrib():Attr("Wlen_correction", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Wlen_correctionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Wlen_correction(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Wlen_correction(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Wlen_correction_allowed(ty);}
};

class Out_volt_fscaleAttrib: public Tango::Attr
{
public:
	Out_volt_fscaleAttrib():Attr("Out_volt_fscale", Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~Out_volt_fscaleAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Out_volt_fscale(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Out_volt_fscale(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Out_volt_fscale_allowed(ty);}
};

class Aperture_areaAttrib: public Tango::Attr
{
public:
	Aperture_areaAttrib():Attr("Aperture_area", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Aperture_areaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Aperture_area(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Aperture_area(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Aperture_area_allowed(ty);}
};

class Area_corrAttrib: public Tango::Attr
{
public:
	Area_corrAttrib():Attr("Area_corr", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Area_corrAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Area_corr(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Area_corr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Area_corr_allowed(ty);}
};

class Gain_factorAttrib: public Tango::Attr
{
public:
	Gain_factorAttrib():Attr("Gain_factor", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Gain_factorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Gain_factor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Gain_factor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Gain_factor_allowed(ty);}
};

class MinAttrib: public Tango::Attr
{
public:
	MinAttrib():Attr("Min", Tango::DEV_DOUBLE, Tango::READ) {};
	~MinAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Min(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Min_allowed(ty);}
};

class MaxAttrib: public Tango::Attr
{
public:
	MaxAttrib():Attr("Max", Tango::DEV_DOUBLE, Tango::READ) {};
	~MaxAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Max(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Max_allowed(ty);}
};

class Std_devAttrib: public Tango::Attr
{
public:
	Std_devAttrib():Attr("Std_dev", Tango::DEV_DOUBLE, Tango::READ) {};
	~Std_devAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Std_dev(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Std_dev_allowed(ty);}
};

class MeanAttrib: public Tango::Attr
{
public:
	MeanAttrib():Attr("Mean", Tango::DEV_DOUBLE, Tango::READ) {};
	~MeanAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Mean(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Mean_allowed(ty);}
};

class Batch_size_timeAttrib: public Tango::Attr
{
public:
	Batch_size_timeAttrib():Attr("Batch_size_time", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Batch_size_timeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Batch_size_time(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Batch_size_time(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Batch_size_time_allowed(ty);}
};

class Sampl_rate_timeAttrib: public Tango::Attr
{
public:
	Sampl_rate_timeAttrib():Attr("Sampl_rate_time", Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~Sampl_rate_timeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Sampl_rate_time(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Sampl_rate_time(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Sampl_rate_time_allowed(ty);}
};

class Sampl_rate_pulseAttrib: public Tango::Attr
{
public:
	Sampl_rate_pulseAttrib():Attr("Sampl_rate_pulse", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Sampl_rate_pulseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Sampl_rate_pulse(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Sampl_rate_pulse(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Sampl_rate_pulse_allowed(ty);}
};

class Batch_size_pulseAttrib: public Tango::Attr
{
public:
	Batch_size_pulseAttrib():Attr("Batch_size_pulse", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~Batch_size_pulseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Batch_size_pulse(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Batch_size_pulse(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Batch_size_pulse_allowed(ty);}
};

class Sub_unitAttrib: public Tango::Attr
{
public:
	Sub_unitAttrib():Attr("Sub_unit", Tango::DEV_STRING, Tango::READ) {};
	~Sub_unitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Sub_unit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Sub_unit_allowed(ty);}
};

class Info_commAttrib: public Tango::Attr
{
public:
	Info_commAttrib():Attr("Info_comm", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Info_commAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Info_comm(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Info_comm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Info_comm_allowed(ty);}
};

class Power_modeAttrib: public Tango::Attr
{
public:
	Power_modeAttrib():Attr("Power_mode", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Power_modeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Power_mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Power_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Power_mode_allowed(ty);}
};

class Trigger_paramAttrib: public Tango::Attr
{
public:
	Trigger_paramAttrib():Attr("Trigger_param", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Trigger_paramAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Trigger_param(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Trigger_param(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Trigger_param_allowed(ty);}
};

class WavelengthAttrib: public Tango::Attr
{
public:
	WavelengthAttrib():Attr("Wavelength", Tango::DEV_LONG, Tango::READ_WRITE) {};
	~WavelengthAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Wavelength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Wavelength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Wavelength_allowed(ty);}
};

class Gain_compAttrib: public Tango::Attr
{
public:
	Gain_compAttrib():Attr("Gain_comp", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Gain_compAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Gain_comp(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Gain_comp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Gain_comp_allowed(ty);}
};

class Auto_rangeAttrib: public Tango::Attr
{
public:
	Auto_rangeAttrib():Attr("Auto_range", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Auto_rangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Auto_range(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Auto_range(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Auto_range_allowed(ty);}
};

class RangeAttrib: public Tango::Attr
{
public:
	RangeAttrib():Attr("Range", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~RangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Range(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Range(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Range_allowed(ty);}
};

class ZeroAttrib: public Tango::Attr
{
public:
	ZeroAttrib():Attr("Zero", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ZeroAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Zero(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Zero(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Zero_allowed(ty);}
};

class Display_lightAttrib: public Tango::Attr
{
public:
	Display_lightAttrib():Attr("Display_light", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Display_lightAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Display_light(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Display_light(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Display_light_allowed(ty);}
};

class Info_probeAttrib: public Tango::Attr
{
public:
	Info_probeAttrib():Attr("Info_probe", Tango::DEV_STRING, Tango::READ) {};
	~Info_probeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Info_probe(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Info_probe_allowed(ty);}
};

class Remote_modeAttrib: public Tango::Attr
{
public:
	Remote_modeAttrib():Attr("Remote_mode", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~Remote_modeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Remote_mode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Remote_mode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Remote_mode_allowed(ty);}
};

class Meas_unitAttrib: public Tango::Attr
{
public:
	Meas_unitAttrib():Attr("Meas_unit", Tango::DEV_STRING, Tango::READ_WRITE) {};
	~Meas_unitAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Meas_unit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<LabmaxTop *>(dev))->write_Meas_unit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Meas_unit_allowed(ty);}
};

class Info_errorAttrib: public Tango::Attr
{
public:
	Info_errorAttrib():Attr("Info_error", Tango::DEV_STRING, Tango::READ) {};
	~Info_errorAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Info_error(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Info_error_allowed(ty);}
};

class Info_statusAttrib: public Tango::Attr
{
public:
	Info_statusAttrib():Attr("Info_status", Tango::DEV_STRING, Tango::READ) {};
	~Info_statusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Info_status(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Info_status_allowed(ty);}
};

class Info_devAttrib: public Tango::Attr
{
public:
	Info_devAttrib():Attr("Info_dev", Tango::DEV_STRING, Tango::READ) {};
	~Info_devAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Info_dev(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Info_dev_allowed(ty);}
};

class Power_energyAttrib: public Tango::Attr
{
public:
	Power_energyAttrib():Attr("Power_energy", Tango::DEV_DOUBLE, Tango::READ) {};
	~Power_energyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<LabmaxTop *>(dev))->read_Power_energy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<LabmaxTop *>(dev))->is_Power_energy_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
#if 0
class GetPower_energyClass : public Tango::Command
{
public:
	GetPower_energyClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetPower_energyClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetPower_energyClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_GetPower_energy_allowed(any);}
};
#endif



class Probe_zeroClass : public Tango::Command
{
public:
	Probe_zeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Probe_zeroClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Probe_zeroClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_Probe_zero_allowed(any);}
};



class Stats_stopClass : public Tango::Command
{
public:
	Stats_stopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Stats_stopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Stats_stopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_Stats_stop_allowed(any);}
};



class Stats_startClass : public Tango::Command
{
public:
	Stats_startClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Stats_startClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Stats_startClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_Stats_start_allowed(any);}
};



class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_Reset_allowed(any);}
};



class Async_cmdClass : public Tango::Command
{
public:
	Async_cmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Async_cmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Async_cmdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<LabmaxTop *>(dev))->is_Async_cmd_allowed(any);}
};



//
// The LabmaxTopClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	LabmaxTopClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static LabmaxTopClass *init(const char *);
	static LabmaxTopClass *instance();
	~LabmaxTopClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	LabmaxTopClass(string &);
	static LabmaxTopClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace LabmaxTop_ns

#endif // _LABMAXTOPCLASS_H
