/*
 * pwrthread.h
 *
 */ 

#ifndef PWRTHREAD_H
#define PWRTHREAD_H

#include <pthread.h>
#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>    
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h>    
#include "LabmaxTop.h"

#if 0
#define QUEUE_LEN 100
#define NULL_READ_BEFORE_STANDBY 10
//abort/init period in us 
#define RFSH_MEAS   1000000 
#endif

class pwrthread : public omni_thread, public Tango::LogAdapter{	
	private:
		LabmaxTop_ns::LabmaxTop *t_read;		
		int interface_type;
		void abort_sleep(double time);
		
	public:
		
		pwrthread(LabmaxTop_ns::LabmaxTop *s);
		
		~pwrthread();
	struct timeval instant;
	struct timeval last_cache_update;
					
	protected:
		void run(void *);	
	Tango::DevDouble tmean;
	Tango::DevDouble tsum;
	Tango::DevDouble tsqsum;
	Tango::DevLong tnsamples;
	Tango::DevDouble tstd_dev;
	Tango::DevDouble tmin;
	Tango::DevDouble tmax;
	Tango::DevString tsub_unit;
	Tango::DevDouble tpower_energy;
	Tango::DevLong tduration;
	Tango::DevVarDoubleArray *power_array;
	void read_cont();	
	void read_rt();	
	
};	



#endif

/* EOF */
